﻿//Aufgabenstellung
//
//1.Import
//
//Als Teil des Entwicklungsteams sollen Sie einen Import für neue Nutzer der jeweiligen Kunden entwickeln.
//Die Kunden schicken zu diesem Zweck CSV-Dateien mit den Daten von neuen Nutzern.
//Diese Daten müssen in die bestehenden Datentabellen eingespielt werden.
//Dafür sind folgende Anforderungen formuliert:
//
//	• Ein Sachbearbeiter ruft eine Konsolen-App auf, in welcher er die Datei und die
//	    Kundennummer des Kunden als Parameter übergibt: Die Beispieldatei hat den Namen "import_yutani.csv" und
//	    gehört zum Kunden mit der Nummer "K2-002"
//
//	• Die Datei hat den Aufbau:
//      - Ein Nutzer mit Anrede, Vorname, Nachname und Geburtsdatum
//      - Ggf. Adresse: Straße mit Hausnummer, PLZ, Stadt
//      - Ggf. E-Mail
//      - Ggf. eine oder mehrere Telefonnummern: Vorwahl ohne führende 0 und Nummer
//
//    	• Ein Nutzer darf für einen Kunden nicht mehrmals importiert werden.
//
//    	• Die Daten sollen wie folgt validiert werden:
//    		○ Geburtsdatum: TT.MM.JJJJ
//    		○ Valide E-Mail-Adresse
//    		○ PLZ: exakt 5 Nummern
//    		○ Telefonnummer 3 bis 5 Nummern für die Vorwahl und 4 bis 10 Nummern für die Hauptnummer. Keine Sonderzeichen
//
//	• Nicht valide Datensätze von Nutzern sollen in einem Protokoll erfasst werden, ebenso bereits vorhandene Nutzer.
//	  Der komplette Datensatz eines Nutzers darf dann nicht importiert werden


using System;
using System.IO;
using MySql.Data;
using MySql.Data.MySqlClient;
using MySqlX.XDevAPI;
using System.Data.Common;
using System.Reflection.PortableExecutable;
using System.Xml;

class Program
{
    static void Main(string[] args)
    {
        //Connection zum Server

        MySql.Data.MySqlClient.MySqlConnection myConnection;
        string myConnectionString;
        //set the correct values for your server, user, password and database name
        myConnectionString = "server=localhost;uid=root;pwd=root;database=import_export";   //ID eventuell von phpMyAdmin ziehen?

        try
        {
            myConnection = new MySql.Data.MySqlClient.MySqlConnection(myConnectionString);
            //open a connection
            myConnection.Open();

            // create a MySQL command and set the SQL statement with parameters
            MySqlCommand myCommand = new MySqlCommand();
            myCommand.Connection = myConnection;
//            myCommand.CommandText = @"SELECT * FROM workshop WHERE maxParticipants = @code;";
            //Selber eingefügt ab hier
            myCommand.CommandText = @"SELECT * FROM user";
            //Hier ende
//            myCommand.Parameters.AddWithValue("@code", "12");

            // execute the command and read the results
            using MySqlDataReader myReader = myCommand.ExecuteReader();


            //Hier dann den CSV Reader benutzen?
            while (myReader.Read())
            {
                int id = myReader.GetInt32("id");
                string name = myReader.GetString("firstname");
                Console.WriteLine(id + " " + name);
            }

            myConnection.Close();
        }
        catch (MySql.Data.MySqlClient.MySqlException ex)
        {

        }

        //Consolen-Ausgabe und Abfrage

        Console.WriteLine("Willkommen");
        Console.Write("Bitte geben Sie nun die Kundenummer ein: ");
        string kundennummer = Console.ReadLine();
        Console.Write("Bitte geben Sie die Datei-Parameter ein: ");
        string dateiBezeichnung = Console.ReadLine();

        string filePath = "path/to/your/" + dateiBezeichnung;    //Wo wird die CSV vor dem einlesen abgelegt? Extra Ordner dafür erstellen

        //Überprüfung einbauen, ob die Datei exisitiert mit if()

        //Schwierigkeit: Bei User beginnen und dann alle anderen Tabellen durch Foreign Keys verbinden/verweisen
        //Procedure INSERT anschauen - Elegante Lösung
        //Auto Increment beachten

        //Umsetzung mit Arrays: Beginnend mit durchzählen für Länge Array, Dann unterteilung in Blöcken
        //(CSV Datei einteilen vor Herr/Frau) , Dann erstellung Tabelle User, dann Andere Tabellen mit Foreign Keys verbinden
    }
}


/*
 * 
 * Die wunderbare Lösung von unserem Kollegen. Nicht getestet aber an den Ansätzen können wir uns orientieren
 * 
using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Text.RegularExpressions;

class Program
{
    static void Main(string[] args)
    {
        if (args.Length != 2)
        {
            Console.WriteLine("Usage: ImportUsers <csv-file> <customer-id>");
            return;
        }

        string filePath = args[0];
        string customerId = args[1];

        if (!File.Exists(filePath))
        {
            Console.WriteLine("File does not exist.");
            return;
        }

        var users = ReadCsvFile(filePath);
        var invalidUsers = new List<string>();
        var validUsers = new List<User>();

        foreach (var user in users)
        {
            if (ValidateUser(user, out string validationError))
            {
                if (!IsUserAlreadyExists(user, customerId))
                {
                    validUsers.Add(user);
                }
                else
                {
                    invalidUsers.Add($"User already exists: {user.FirstName} {user.LastName}, Email: {user.Email}");
                }
            }
            else
            {
                invalidUsers.Add(validationError);
            }
        }

        ImportValidUsers(validUsers, customerId);
        LogInvalidUsers(invalidUsers);

        Console.WriteLine("Import completed.");
    }

    static List<User> ReadCsvFile(string filePath)
    {
        var users = new List<User>();
        var lines = File.ReadAllLines(filePath);

        foreach (var line in lines)
        {
            var columns = line.Split(',');

            var user = new User
            {
                Salutation = columns[0],
                FirstName = columns[1],
                LastName = columns[2],
                BirthDate = columns[3],
                Street = columns[4],
                PostalCode = columns[5],
                City = columns[6],
                Email = columns[7],
                PhoneNumbers = columns.Skip(8).ToList()
            };

            users.Add(user);
        }

        return users;
    }

    static bool ValidateUser(User user, out string error)
    {
        error = string.Empty;
        DateTime birthDate;

        if (!DateTime.TryParseExact(user.BirthDate, "dd.MM.yyyy", CultureInfo.InvariantCulture, DateTimeStyles.None, out birthDate))
        {
            error = $"Invalid birth date: {user.BirthDate}";
            return false;
        }

        if (!Regex.IsMatch(user.Email, @"^[^@\s]+@[^@\s]+\.[^@\s]+$"))
        {
            error = $"Invalid email: {user.Email}";
            return false;
        }

        if (!Regex.IsMatch(user.PostalCode, @"^\d{5}$"))
        {
            error = $"Invalid postal code: {user.PostalCode}";
            return false;
        }

        foreach (var phone in user.PhoneNumbers)
        {
            var parts = phone.Split('-');
            if (parts.Length != 2 || !Regex.IsMatch(parts[0], @"^\d{3,5}$") || !Regex.IsMatch(parts[1], @"^\d{4,10}$"))
            {
                error = $"Invalid phone number: {phone}";
                return false;
            }
        }

        return true;
    }

    static bool IsUserAlreadyExists(User user, string customerId)
    {
        // Hier sollte die Logik implementiert werden, um zu prüfen, ob der Nutzer bereits in der Datenbank vorhanden ist.
        // Dies ist ein Platzhalter für die tatsächliche Überprüfung in der Datenbank.
        return false;
    }

    static void ImportValidUsers(List<User> users, string customerId)
    {
        // Hier sollte die Logik implementiert werden, um die gültigen Nutzer in die Datenbank zu importieren.
        // Dies ist ein Platzhalter für den tatsächlichen Datenbankimport.
    }

    static void LogInvalidUsers(List<string> invalidUsers)
    {
        using (StreamWriter sw = new StreamWriter("invalid_users.log"))
        {
            foreach (var error in invalidUsers)
            {
                sw.WriteLine(error);
            }
        }
    }
}

class User
{
    public string Salutation { get; set; }
    public string FirstName { get; set; }
    public string LastName { get; set; }
    public string BirthDate { get; set; }
    public string Street { get; set; }
    public string PostalCode { get; set; }
    public string City { get; set; }
    public string Email { get; set; }
    public List<string> PhoneNumbers { get; set; }
}
*/

